/***
*  Scrolbar.prg
*   ⨪   ६騬 㪠⥫ ⥪饩
*  樨,  ਬ⥫쭮  TBrowse-ꥪ⠬, ACHOICE(), DBEDIT()
*   MEMOEDIT().
*
*  Copyright (c) 1990, Nantucket Corp.   ࠢ ࠭.
*  David R. Allison
*
*  ஢  ﬨ: /N/W
*
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


#include "Fileman.ch"

/***
*  ScrollBarNew( <nTopRow>, <nTopColumn>, <nBottomRow>,
*     <cColorString>, <nInitPosition> ) --> aScrollBar
*
*   ᨢ  न⠬    ⥬ ⮡ࠦ
*
*/
FUNCTION ScrollBarNew( nTopRow, nTopColumn, nBottomRow, ;
                        cColorString, nInitPosition )

   LOCAL aScrollBar := ARRAY( TB_ELEMENTS )

   aScrollBar[ TB_ROWTOP ]    := nTopRow
   aScrollBar[ TB_COLTOP ]    := nTopColumn
   aScrollBar[ TB_ROWBOTTOM ] := nBottomRow
   aScrollBar[ TB_COLBOTTOM ] := nTopColumn

   // ⠭   ୮  ய᪥ ࠬ ᯥ饣 梥
   IF cColorString == NIL
      cColorString := "W/N"
   ENDIF
   aScrollBar[ TB_COLOR ]     := cColorString

   // ⠭ ⮢ 樨 㪠⥫ 
   IF nInitPosition == NIL
      nInitPosition := 1
   ENDIF
   aScrollBar[ TB_POSITION ]  := nInitPosition

   RETURN aScrollBar

/***
*  ScrollBarDisplay( <aScrollBar> ) --> aScrollBar
*  ⮡ࠦ   㪠⥫ ⥪饣 
*
*/
FUNCTION ScrollBarDisplay( aScrollBar )
   LOCAL cOldColor, nRow

   cOldColor := SETCOLOR( aScrollBar[ TB_COLOR ] )

   // ᮢ ५ - 㪠⥫ ࠢ
   @ aScrollBar[ TB_ROWTOP ], aScrollBar[ TB_COLTOP ] SAY TB_UPARROW
   @ aScrollBar[ TB_ROWBOTTOM ], aScrollBar[ TB_COLBOTTOM ] SAY TB_DNARROW

   // ᮢ 䮭
   FOR nRow := (aScrollBar[ TB_ROWTOP ] + 1) TO (aScrollBar[ TB_ROWBOTTOM ] - 1)
      @ nRow, aScrollBar[ TB_COLTOP ] SAY TB_BACKGROUND
   NEXT

   SETCOLOR( cOldColor )

   RETURN aScrollBar

/***
*  ScrollBarUpdate( <aScrollBar>, <nCurrent>, <nTotal>,
*     <lForceUpdate> ) --> aScrollBar
*
*   樨 㪠⥫ ⥪饣 
*
*/
FUNCTION ScrollBarUpdate( aScrollBar, nCurrent, nTotal, lForceUpdate )

   LOCAL cOldColor, nNewPosition
   LOCAL nScrollHeight := (aScrollBar[TB_ROWBOTTOM] - 1) - ;
         (aScrollBar[TB_ROWTOP])

   IF nTotal < 1
      nTotal := 1
   ENDIF

   IF nCurrent < 1
      nCurrent := 1
   ENDIF

   IF nCurrent > nTotal
      nCurrent := nTotal
   ENDIF

   IF lForceUpdate == NIL
      lForceUpdate := .F.
   ENDIF

   cOldColor := SETCOLOR( aScrollBar[ TB_COLOR ] )

   // ᫥  樨
   nNewPosition := ROUND( (nCurrent / nTotal) * nScrollHeight, 0 )

   //  ४   㪠⥫
   nNewPosition := IF( nNewPosition < 1, 1, nNewPosition )
   nNewPosition := IF( nCurrent == 1, 1, nNewPosition )
   nNewPosition := IF( nCurrent >= nTotal, nScrollHeight, nNewPosition )

   // 襢 ன 樨 (᫨ )  ࠧᮢ 
   IF nNewPosition <> aScrollBar[ TB_POSITION ] .OR. lForceUpdate
      @ (aScrollBar[ TB_POSITION ] + aScrollBar[ TB_ROWTOP ]), ;
         aScrollBar[ TB_COLTOP ] SAY TB_BACKGROUND
      @ (nNewPosition + aScrollBar[ TB_ROWTOP ]), aScrollBar[ TB_COLTOP ] SAY ;
        TB_HIGHLIGHT
      aScrollBar[ TB_POSITION ] := nNewPosition
   ENDIF

   SETCOLOR( cOldColor )

   RETURN aScrollBar
